#!/usr/bin/env ruby

# most distributions use utf8 for the default text encoding.
# this program converts euc to utf8.

# sometimes kconv fails to convert strings,
# so I use iconv.
require 'iconv'

#############################
# convert euc to utf8
#############################
convert_utf8 = Proc.new do
	file_orig = File.new($filename, "r")
		entries = file_orig.read
	file_orig.close

	dicfile = File.new($dicname, "w")
		iconv = Iconv.new('UTF-8', 'EUC-JP')
		entries = iconv.iconv(entries)
		dicfile.puts entries
	dicfile.close
end


#############################
# main
#############################
targetfiles = ARGV

if ARGV == []
	puts "Usage: utf8-contents-converter.rb [FILE]"
	exit
end

targetfiles.length.times do |i|
	$filename = targetfiles[i]
	$dicname = $filename + ".utf8"

	convert_utf8.call
end
