#!/usr/bin/ruby

require "kconv"
require "rexml/document"
require "open-uri"
require "readline"


#############################
# get yahoo results
#############################
get_yahooresults = Proc.new do
	# I selected "blog.goo.ne.jp" to get word frequencies in daily use.
	# Goo Blog is a popular blog service and yahoo search has huge indexes of that.
	url = "http://api.search.yahoo.co.jp/WebSearchService/V1/webSearch?site=blog.goo.ne.jp&appid=" + \
		$appid + \
		"&type=phrase&results=1&query="

	origdic = File.new($filename, "r")
		lines = origdic.readlines
	origdic.close

	freqdic = File.new($dicname, "w")

	lines.length.times do |n|
		# get hyouki from edict
		hyouki = lines[n].split(" /")[0]
		hyouki = hyouki.split(" [")[0]

		# search hyouki by yahoo search
		begin
			result = open(URI.escape(url + hyouki))
		rescue => err1
			puts err1

			# we can't check over 50000 words in 24 hours.
			# in that case, yahoo returns "403 Forbidden".
			if err1.to_s.index("403 Forbidden") != nil
				exit
			else
				sleep 3
				retry
			end
		end

		doc = REXML::Document.new(result)

		# get numbers of hits from yahoo search results
		doc = doc.to_s.split("\n")
		c = doc[1].to_s.split(" ")[-3]
		c = c.gsub("totalResultsAvailable=", "")
		c = c.gsub("'", "")
		c = c.gsub("pgr=", "")

		freqdic.puts lines[n].chomp + \
				"###" + c + "/"
	end

	freqdic.close
end


#############################
# main
#############################
targetfiles = ARGV

if ARGV == []
	puts "Usage: ruby get-yahooresults.rb [FILE]"
	exit
end

# we need to show the messages to use "yahoo developer network".
puts
puts "このアプリケーションはYahoo!デベロッパーネットワークを利用しています。"
puts "Webサービス by Yahoo! JAPAN"
puts "http://developer.yahoo.co.jp/about"
puts

# you need to get "application ID" first.
# http://e.developer.yahoo.co.jp/webservices/register_application
# then enter your ID.
puts "Enter your application ID"
$appid = Readline.readline.chomp
puts

targetfiles.length.times do |i|
	$filename = targetfiles[i]
	$dicname = $filename + ".yahoo"

	get_yahooresults.call
end

puts "Done."
puts
